<template>
    <div class="c-general-info-section">
        <div class="c-table-box">
            <div class="c-filter-box h-rowflex">
                <div class="c-filter-box__item " v-if="filter.active" v-for="filter in filter_conf" :key="filter.label">
                    <div v-if="filter.control_type === 'list'">
                        <b-dropdown split :text="filter.option_selected.name">
                            <b-dropdown-item 
                            v-for="(option,index) in filter.values" 
                            :key="index" 
                            @click="filter.option_selected = option, multipleFilter()">
                                {{option.name}}
                            </b-dropdown-item>
                        </b-dropdown>
                    </div>
                    <div v-if="filter.control_type === 'input'" class="">
                        <input type="text" class="c-search-box-filter" :placeholder="filter.label" v-model="filter.search_text" @change="multipleFilter">
                    </div>
                </div>
                <b-button class="c-btn-primary c-filter-box__item" v-b-modal.active-filters-modal variant="none">
                    <span class="icon-plus-circle"></span>  Add filter
                </b-button>
            </div>
            <h5 class="requests-counter" v-if="user_requests_filtered && user_requests_filtered.length > 1">
                {{user_requests_filtered.length}} requests
            </h5>
            <h5 class="requests-counter" v-else-if="user_requests_filtered && user_requests_filtered.length === 1">
                {{user_requests_filtered.length}} request
            </h5>
            <h5 class="requests-counter" v-else>
                No requests
            </h5>
            <div class="row" v-if="user_requests_filtered.length > 0">
                <div class="col-lg-12 col-sm-12 col-sm-12">
                    <div class="table-responsive">
                        <table class="table">
                            <thead>
                                <tr>
                                    <!-- eslint-disable -->
                                    <th v-if="col.visible" v-for="col in table_conf" :key="col.column_name">{{col.column_alias}}</th>
                                    <!-- eslint-enable -->
                                </tr>
                            </thead>
                            <tbody class="">
                                <tr v-for="req in user_requests_filtered" :key="req.id">
                                    <td  v-if="col.visible" v-for="col in table_conf" :key="col.column_name">
                                        <div class="td__info">
                                            <span :class="col.semaphore_before[req[col.column_name]]" v-if="col.semaphore_before"></span>    
                                            {{req[col.column_name]}}
                                            <span v-if="col.symbol_after">{{col.symbol_after}}</span>    
                                        </div>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
        <div v-if="user_requests_filtered.length <= 0"  class="c-table-box">
            <div class="c-table-box__empty-messages">
                <span class="icon-wind"></span>
                <p>No requests  <br> ¡Try diferent filters!</p>
            </div>
        </div>
        <div>
            <b-modal id="active-filters-modal" size="sm" ref="active-filters-modal" title="Activate filters" centered hide-footer>
                <div class="c-checbox-list">
                    <div class="c-checbox-list__item " :class="{active:filter.active}" v-if="filter.available" v-for="filter in filter_conf" :key="filter.label">
                        <div class="c-custom-check" @click="filter.active = !filter.active">
                            <span v-if="filter.active" class="icon-check"></span>
                        </div>
                        {{filter.label}}
                    </div>
                </div>
                <b-button class="c-btn-primary   mt-4" block variant="none" @click="hideModal('active-filters-modal')">
                    <span class="icon-check-circle"></span>  OK
                </b-button>
            </b-modal>
        </div>
    </div>
</template>
<script>
export default {
    props: {
        filter_conf: Array,
        table_conf: Array,
        user_requests: Array
    },
    data() {
        return {
            user_requests_filtered : []
        };
    },
    created(){
        this.filter_conf.map( filter_item => {
            if(filter_item.control_type === 'list' && filter_item.values && filter_item.values.length > 0){
                this.$set(filter_item, 'option_selected', filter_item.values[0])
            }
            let col = this.table_conf.find( (column) => {
                return (column.column_name === filter_item._id && column.visible === true)
            })
            if(col){
                this.$set(filter_item, 'available', true)
            }
        })
        this.user_requests_filtered = [...this.user_requests];
    },
    methods:{
        multipleFilter(){
            this.user_requests_filtered =  [...this.user_requests];
            this.filter_conf.map( filter_item => {
                if(filter_item.control_type === 'list' && filter_item.active){
                    this.user_requests_filtered = this.filterData(this.user_requests_filtered, filter_item._id, filter_item.option_selected._id, filter_item.option_selected.operator)
                }else if(filter_item.control_type === 'input' && filter_item.active){
                    this.user_requests_filtered = this.filterData(this.user_requests_filtered, filter_item._id, filter_item.search_text, "include")
                }
            })
        },
        filterData(data,field,value,op){
            var operators = {
                'include': function(a, b) { return a.toLowerCase().includes(b.toLowerCase())},
                'equal': function(a, b) { return a === b },
                'lt': function(a, b) { return a < b },
                'gt': function(a, b) { return a > b },
            }
            if(op){
                return data.filter( item => {
                    return operators[op](item[field], value)
                })
            }
            return data
        },
        hideModal(id) {
            this.$refs[id].hide()
        }
    }
}
</script>
<style>
.requests-counter{
    padding-left: 0.75rem;
    color: #36403f
}

</style>